Index: /trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 331)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 332)
@@ -3165,5 +3165,5 @@
 }
 
-#if LG_RESTRICTEDRESPRED_M24766
+#if H3D_IVRP
 Void TComDataCU::getPartIndexAndSize( UInt uiPartIdx, UInt& ruiPartAddr, Int& riWidth, Int& riHeight, UInt uiAbsPartIdx, Bool bLCU)
 {
@@ -3250,73 +3250,4 @@
 #endif
 
-#if LG_RESTRICTEDRESPRED_M24766 && !MTK_MDIVRP_C0138
-Int TComDataCU::getResiPredMode(UInt uiPartAddr)
-{
-  Int iAddResiShift = -1;
-
-  for(UInt uiRefIdx = 0; uiRefIdx < 2; uiRefIdx++)
-  {
-    RefPicList eRefList = uiRefIdx ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
-    Int iBestRefIdx = getCUMvField(eRefList)->getRefIdx(uiPartAddr);
-    if(iBestRefIdx >= 0 && getSlice()->getViewId() == getSlice()->getRefViewId(eRefList, iBestRefIdx))
-      iAddResiShift++;
-  }
-
-  return iAddResiShift;
-}
-
-Void TComDataCU::getPUResiPredShift(Int *iPUResiPredShift, UInt uiAbsPartIndex)
-{
-  UInt uiPartSize = getPartitionSize(uiAbsPartIndex);
-  UInt uiPartAddr;
-  Int iWidth, iHeight;
-  Int iAddResiShift;
-
-  if(uiPartSize == SIZE_2Nx2N)
-  {
-    iAddResiShift = getResiPredMode(uiAbsPartIndex);
-    for(UInt i = 0; i < 4; i++)
-      iPUResiPredShift[i] = (getSlice()->getPPS()->getUseWP() || getInterDir(uiAbsPartIndex) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-    return;
-  }
-
-  if(uiPartSize == SIZE_2NxN || uiPartSize == SIZE_2NxnU || uiPartSize == SIZE_2NxnD)
-  {
-    for(UInt i = 0; i < 2; i++)
-    {
-      getPartIndexAndSize(i, uiPartAddr, iWidth, iHeight, uiAbsPartIndex, true);
-      uiPartAddr += uiAbsPartIndex;
-      iAddResiShift = getResiPredMode(uiPartAddr);
-      iPUResiPredShift[2*i] = iPUResiPredShift[2*i+1] = (getSlice()->getPPS()->getUseWP() || getInterDir(uiPartAddr) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-    }
-    return;
-  }
-
-  if(uiPartSize == SIZE_Nx2N || uiPartSize == SIZE_nLx2N || uiPartSize == SIZE_nRx2N)
-  {
-    for(UInt i = 0; i < 2; i++)
-    {
-      getPartIndexAndSize(i, uiPartAddr, iWidth, iHeight, uiAbsPartIndex, true);
-      uiPartAddr += uiAbsPartIndex;
-      iAddResiShift = getResiPredMode(uiPartAddr);
-      iPUResiPredShift[i] = iPUResiPredShift[2+i] = (getSlice()->getPPS()->getUseWP() || getInterDir(uiPartAddr) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-    }
-    return;
-  }
-
-  if(uiPartSize == SIZE_NxN)
-  {
-    for(UInt i = 0; i < 4; i++)
-    {
-      getPartIndexAndSize(i, uiPartAddr, iWidth, iHeight, uiAbsPartIndex, true);
-      uiPartAddr += uiAbsPartIndex;
-      iAddResiShift = getResiPredMode(uiPartAddr);
-      iPUResiPredShift[i] = (getSlice()->getPPS()->getUseWP() || getInterDir(uiPartAddr) != 3) ? (iAddResiShift >= 0 ? 0 : -1) : (iAddResiShift >= 0 ? 1-iAddResiShift : -1);
-    }
-  }
-
-}
-#endif
-
 Void TComDataCU::getMvField ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefPicList, TComMvField& rcMvField )
 {
@@ -3653,5 +3584,5 @@
 #endif //H3D_NBDV
 
-#if MTK_MDIVRP_C0138
+#if H3D_IVRP
   Bool bDVAvail = true;
 #endif
@@ -3668,5 +3599,5 @@
 #if MERL_VSP_C0152
             , true
-#endif
+#endif      
 );
   }
@@ -3693,5 +3624,5 @@
     cDisInfo.m_acMvCand[0].setVer(0);
     cDisInfo.m_aVIdxCan[0] = 0;
-#if MTK_MDIVRP_C0138
+#if H3D_IVRP
     bDVAvail = false;
 #endif
@@ -3748,10 +3679,6 @@
 
   Int iPdmDir[2] = {0, 0};
-#if QC_AMVP_MRG_UNIFY_IVCAN_C0051
   getUnifiedMvPredCan(uiPUIdx, REF_PIC_LIST_0, 0, aiPdmRefIdx, acPdmMv, &cDisInfo, iPdmDir, true);
   Int iPdmInterDir;
-#else
-  Int     iPdmInterDir      = cDisInfo.iN==0? 0:getPdmMergeCandidateDisCan ( uiPUIdx, aiPdmRefIdx, acPdmMv, &cDisInfo, iPdmDir );
-#endif
 #else // H3D_NBDV
   Int iPdmDir[2] = {0, 0};
@@ -3760,5 +3687,5 @@
   iPdmDir[1] = iPdmInterDir; 
 #endif // H3D_NBDV
-#if MTK_MDIVRP_C0138
+#if H3D_IVRP
   if (m_pcSlice->getSPS()->getMultiviewResPredMode()==1 && iPdmDir[0] && !bNoPdmMerge && cCurPS == SIZE_2Nx2N && bDVAvail)
   {
@@ -3767,5 +3694,5 @@
 #endif
 
-  if( iPdmDir[0] && !bNoPdmMerge && PDM_MERGE_POS == 0 )
+  if( iPdmDir[0] && !bNoPdmMerge )
   {
     abCandIsInter        [ iCount ] = true;
@@ -3798,30 +3725,6 @@
     }
     iCount ++;
-  }
-
-  if(extraMergeCand)
-  {
-    if(!bNoPdmMerge && iPdmDir[1] && DMV_MERGE_POS == 1)
-    {
-      assert(iCount < MRG_MAX_NUM_CANDS_MEM);
-      abCandIsInter        [ iCount ] = true;
-      puhInterDirNeighbours[ iCount ] = iPdmDir[1];
-      if( ( iPdmDir[1] & 1 ) == 1 )
-      {
-        pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 2 ], aiPdmRefIdx[ 2 ] );
-      }
-      if( ( iPdmDir[1] & 2 ) == 2 )
-      {
-        pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 3 ], aiPdmRefIdx[ 3 ] );
-      }
-#if H3D_NBDV
-      pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
-      pcMvFieldNeighbours[(iCount<<1)+1].getMv().m_bDvMcp = false;
-#endif
-      if ( mrgCandIdx == iCount )
-          return;
-      iCount ++;
-    }    
-  }
+  }  
+  
 #endif //  H3D_IVMP 
 
@@ -3910,44 +3813,4 @@
   }
 
-#if H3D_IVMP
-  if( iPdmDir[0]   && !bNoPdmMerge && PDM_MERGE_POS == 1 )
-  {
-    abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmInterDir;
-    if( ( iPdmInterDir & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 0 ], aiPdmRefIdx[ 0 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[ iCount<<1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if( ( iPdmInterDir & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 1 ], aiPdmRefIdx[ 1 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if ( mrgCandIdx == iCount )
-    {
-      return;
-    }
-    iCount ++;
-  }
-#endif //  H3D_IVMP 
-
-#if MERL_VSP_COMPENSATION_C0152
-  //===== vsp 1 =====
-  if( iCount < 4 + extraMergeCand )
-    if ( !xAddVspMergeCand(1, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
-      return;
-#endif
-
   // above
   UInt uiAbovePartIdx = 0;
@@ -4022,44 +3885,4 @@
   }
 
-#if H3D_IVMP
-  if( iPdmDir[0]   && !bNoPdmMerge && PDM_MERGE_POS == 2 )
-  {
-    abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmInterDir;
-    if( ( iPdmInterDir & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 0 ], aiPdmRefIdx[ 0 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[ iCount<<1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if( ( iPdmInterDir & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 1 ], aiPdmRefIdx[ 1 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if ( mrgCandIdx == iCount )
-    {
-      return;
-    }
-    iCount ++;
-  }
-#endif //  H3D_IVMP 
-
-#if MERL_VSP_COMPENSATION_C0152
-  //===== vsp 2 =====
-  if( iCount < 4 + extraMergeCand )
-    if ( !xAddVspMergeCand(2, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
-      return;
-#endif
-
   // above right
   UInt uiAboveRightPartIdx = 0;
@@ -4109,38 +3932,8 @@
 
 #if H3D_IVMP
-  if( iPdmDir[0]   && !bNoPdmMerge && PDM_MERGE_POS == 3 )
-  {
-    abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmInterDir;
-    if( ( iPdmInterDir & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 0 ], aiPdmRefIdx[ 0 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[ iCount<<1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if( ( iPdmInterDir & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 1 ], aiPdmRefIdx[ 1 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if ( mrgCandIdx == iCount )
-    {
-      return;
-    }
-    iCount ++;
-  }
 
   if(extraMergeCand)
   {
-    if(!bNoPdmMerge && iPdmDir[1] && DMV_MERGE_POS == 4)
+    if(!bNoPdmMerge && iPdmDir[1] )
     {
       assert(iCount < MRG_MAX_NUM_CANDS_MEM);
@@ -4187,21 +3980,4 @@
 #endif // H3D_IVMP 
 
-#if MERL_VSP_COMPENSATION_C0152
-  //===== vsp 3 =====
-  if( iCount < 4 + extraMergeCand )
-    if ( !xAddVspMergeCand(3, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
-      return;
-#endif
-
-#if MERL_VSP_C0152
-#if VSP_MERGE_POS < 4
-#if H3D_IVMP
-  if( iCount < 4 + extraMergeCand )
-#else
-  if( iCount < 4 )
-#endif
-  {
-#endif
-#endif
 
   //left bottom
@@ -4250,49 +4026,5 @@
     iCount ++;
   }
-#if MERL_VSP_C0152
-#if VSP_MERGE_POS < 4
-  }
-#endif
-#endif
-  
-#if H3D_IVMP
-  if( iPdmDir[0]   && !bNoPdmMerge && PDM_MERGE_POS == 4 )
-  {
-    abCandIsInter        [ iCount ] = true;
-    puhInterDirNeighbours[ iCount ] = iPdmInterDir;
-    if( ( iPdmInterDir & 1 ) == 1 )
-    {
-      pcMvFieldNeighbours[ iCount<<1    ].setMvField( acPdmMv[ 0 ], aiPdmRefIdx[ 0 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[ iCount<<1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if( ( iPdmInterDir & 2 ) == 2 )
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( acPdmMv[ 1 ], aiPdmRefIdx[ 1 ] );
-    }
-#if FIX_CU_BASED_MRG_CAND_LIST_B0136
-    else
-    {
-      pcMvFieldNeighbours[(iCount<<1)+1 ].setMvField( TComMv(0,0), NOT_VALID );
-    }
-#endif
-    if ( mrgCandIdx == iCount )
-    {
-      return;
-    }
-    iCount ++;
-  }
-#endif //  H3D_IVMP 
-
-#if MERL_VSP_COMPENSATION_C0152
-  //===== vsp 4 =====
-  if( iCount < 4 + extraMergeCand )
-    if ( !xAddVspMergeCand(4, 1, bVspMvZeroDone, uiDepth, abCandIsInter, iCount, puhInterDirNeighbours, pcMvFieldNeighbours, iVSPIndexTrue, mrgCandIdx, &cDisInfo) )
-      return;
-#endif
+ 
   
   // above left
@@ -5164,37 +4896,23 @@
 
 #if MERL_VSP_C0152
-#if LGE_SIMP_DVP_REFINE_C0112
-Pel TComDataCU::getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec, Bool bSimpleDvpRefine)
-#else
-Pel TComDataCU::getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec)
-#endif
+Pel TComDataCU::getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iBlkWidth, Int iBlkHeight, Int* aiShiftLUT, Int iShiftPrec, Bool bSimpleDvpRefine)
 {
   Int depStride =  pcBaseViewDepthPicYuv->getStride();
 
-  Int width  = pcBaseViewDepthPicYuv->getWidth();
-  Int height = pcBaseViewDepthPicYuv->getHeight();
-#if MTK_DVPREFINE_BVSP_BUG_FIX
-  Int depthPosX = Clip3(0,   width - iWidth,  iBlkX + (mv->getHor()>>2));
-  Int depthPosY = Clip3(0,   height - iHeight,  iBlkY + (mv->getVer()>>2));
-#else
-  Int depthPosX = Clip3(0,   width - iWidth  - 1,  iBlkX + (mv->getHor()>>2));
-  Int depthPosY = Clip3(0,   height- iHeight - 1,  iBlkY + (mv->getVer()>>2));
-#endif
-  Pel *depth  = pcBaseViewDepthPicYuv->getLumaAddr() + depthPosX + depthPosY * depStride;
-  Pel  maxDepth = 0;
-#if LGE_SIMP_DVP_REFINE_C0112
+  Int iPictureWidth  = pcBaseViewDepthPicYuv->getWidth();
+  Int iPictureHeight = pcBaseViewDepthPicYuv->getHeight();
+
+  Int depthPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + (mv->getHor()>>2));
+  Int depthPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + (mv->getVer()>>2));
+
+  Pel *pDepthPel   = pcBaseViewDepthPicYuv->getLumaAddr() + depthPosX + depthPosY * depStride;
+  Pel  maxDepthVal = 0;
+
   if ( bSimpleDvpRefine )
   {
-#if MTK_DVPREFINE_BVSP_BUG_FIX
-    Int depthStartPosX = Clip3(0,   width - iWidth,  iBlkX + (mv->getHor()>>2));
-    Int depthStartPosY = Clip3(0,   height - iHeight,  iBlkY + (mv->getVer()>>2));
-    Int depthEndPosX = Clip3(0,   width - 1,  iBlkX + iWidth - 1  + (mv->getHor()>>2));
-    Int depthEndPosY = Clip3(0,   height - 1,  iBlkY + iHeight - 1 + (mv->getVer()>>2));
-#else
-    Int depthStartPosX = Clip3(0,   width - iWidth  - 1,  iBlkX + (mv->getHor()>>2));
-    Int depthStartPosY = Clip3(0,   height- iHeight - 1,  iBlkY + (mv->getVer()>>2));
-    Int depthEndPosX = Clip3(0,   width - iWidth  - 1,  iBlkX + iWidth  + (mv->getHor()>>2));
-    Int depthEndPosY = Clip3(0,   height- iHeight - 1,  iBlkY + iHeight + (mv->getVer()>>2));
-#endif
+    Int depthStartPosX = Clip3(0,   iPictureWidth - iBlkWidth,  iBlkX + (mv->getHor()>>2));
+    Int depthStartPosY = Clip3(0,   iPictureHeight- iBlkHeight,  iBlkY + (mv->getVer()>>2));
+    Int depthEndPosX   = Clip3(0,   iPictureWidth - 1,  iBlkX + iBlkWidth - 1 + (mv->getHor()>>2));
+    Int depthEndPosY   = Clip3(0,   iPictureHeight - 1,  iBlkY + iBlkHeight - 1 + (mv->getVer()>>2));
     Int iCenterX = (depthStartPosX + depthEndPosX) >> 1;
     Int iCenterY = (depthStartPosY + depthEndPosY) >> 1;
@@ -5209,40 +4927,26 @@
     for (Int i = 0; i < 5; i++)
     {
-      if (maxDepth < aiDepth[i])
-        maxDepth = aiDepth[i];
+      if (maxDepthVal < aiDepth[i])
+        maxDepthVal = aiDepth[i];
     }
   }
   else
   {
-    for (Int j = 0; j < iHeight; j++)
-    {
-      for (Int i = 0; i < iWidth; i++)
-      {
-        if (maxDepth < depth[i])
-          maxDepth = depth[i];
-      }
-      depth += depStride;
-    }
-  }
-#else
-  for (Int j = 0; j < iHeight; j++)
-  {
-    for (Int i = 0; i < iWidth; i++)
-    {
-      if (maxDepth < depth[i])
-        maxDepth = depth[i];
-    }
-    depth += depStride;
-  }
-#endif
-  Int disparity = aiShiftLUT[ maxDepth ] << iShiftPrec;
-
-  return disparity;
-}
-#if LGE_SIMP_DVP_REFINE_C0112
+    for (Int j = 0; j < iBlkHeight; j++)
+    {
+      for (Int i = 0; i < iBlkWidth; i++)
+      {
+        if (maxDepthVal < pDepthPel[i])
+          maxDepthVal = pDepthPel[i];
+  }
+      pDepthPel += depStride;
+    }
+  }
+
+  Int iDisp = aiShiftLUT[ maxDepthVal ] << iShiftPrec;
+
+  return iDisp;
+}
 Void TComDataCU::estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred, Bool bSimpleDvpRefine)
-#else
-Void TComDataCU::estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred)
-#endif
 {
   if (picDepth)
@@ -5257,11 +4961,9 @@
     Int* aiShiftLUT;
     Int  iShiftPrec;
+
     getSlice()->getBWVSPLUTParam(aiShiftLUT, iShiftPrec);
-#if LGE_SIMP_DVP_REFINE_C0112
-    Pel x = getMcpFromDM( pcBaseViewDepthPicYuv, cMvPred, iBlkX, iBlkY, iWidth, iHeight, aiShiftLUT, iShiftPrec, bSimpleDvpRefine );
-#else
-    Pel x = getMcpFromDM( pcBaseViewDepthPicYuv, cMvPred, iBlkX, iBlkY, iWidth, iHeight, aiShiftLUT, iShiftPrec);
-#endif
-    cMvPred->setHor(x);
+
+    Pel iDisp = getMcpFromDM( pcBaseViewDepthPicYuv, cMvPred, iBlkX, iBlkY, iWidth, iHeight, aiShiftLUT, iShiftPrec, bSimpleDvpRefine );
+    cMvPred->setHor( iDisp );
     clipMv(*cMvPred);
   }
@@ -5270,5 +4972,109 @@
 
 #if H3D_NBDV
-Void TComDataCU::getDisMvpCandNBDV( UInt uiPartIdx, UInt uiPartAddr,DisInfo* pDInfo , Bool bParMerge
+
+Bool TComDataCU::xCheckSpatialNBDV( TComDataCU* pcTmpCU, UInt uiIdx, UInt uiPartIdx, UInt uiPartAddr, DisInfo* pNbDvInfo, Bool bSearchForMvpDv, McpDisInfo* paMvpDvInfo, UInt uiMvpDvPos, Bool bDepthRefine )
+{
+  if( pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
+  {
+    Bool bTmpIsSkipped = pcTmpCU->isSkipped( uiIdx );
+    for(Int iList = 0; iList < (getSlice()->isInterB() ? 2: 1); iList ++)
+    {
+      RefPicList eRefPicList = RefPicList(iList);
+      Int      refId = pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) ;
+      TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
+
+      if( refId >= 0)
+      {
+        Int refViewIdx  = pcTmpCU->getSlice()->getRefViewId( eRefPicList, refId );
+        if (refViewIdx != m_pcSlice->getViewId()) // DCP
+        {          
+          clipMv(cMvPred);
+
+          TComPic* picDepth = getSlice()->getRefPicBaseDepth();
+
+          if (picDepth && bDepthRefine)
+            estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred, true);
+
+          pNbDvInfo->m_acMvCand[ pNbDvInfo->iN   ] = cMvPred;
+          pNbDvInfo->m_aVIdxCan[ pNbDvInfo->iN++ ] = refViewIdx;
+
+          return true;
+        }
+        else if ( bSearchForMvpDv && cMvPred.m_bDvMcp && bTmpIsSkipped )
+        {
+          assert( uiMvpDvPos < MCP_DIS_CANS );
+          paMvpDvInfo->m_acMvCand[iList][ uiMvpDvPos ] = TComMv( cMvPred.m_iDvMcpDispX, cMvPred.m_iDvMcpDispY );
+          paMvpDvInfo->m_aVIdxCan[iList][ uiMvpDvPos ] = 0; // works only for CTC
+          paMvpDvInfo->m_bAvailab[iList][ uiMvpDvPos ] = true;
+          paMvpDvInfo->m_bFound                        = true; 
+        }
+      }
+#if MERL_VSP_C0152
+      else if (pcTmpCU->getVSPIndex(uiIdx) != 0) // is VSP
+      { 
+        TComPic* picDepth = pcTmpCU->getSlice()->getRefPicBaseDepth();
+        if (picDepth && bDepthRefine)
+          estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cMvPred);
+
+        cMvPred.setVer(0);
+
+        pNbDvInfo->m_acMvCand[ pNbDvInfo->iN]   = cMvPred;
+        pNbDvInfo->m_aVIdxCan[ pNbDvInfo->iN++] = 0; // refViewIdx;
+        return true;
+      }
+#endif
+    }
+  }
+  return false; 
+}
+
+
+Void TComDataCU::xDeriveRightBottomNbIdx( PartSize eCUMode, UInt uiPartIdx, Int &riLCUIdxRBNb, Int &riPartIdxRBNb )
+{
+  UInt uiNumPartInCUWidth = m_pcPic->getNumPartInWidth();  
+  Int uiLCUIdx = getAddr();
+
+  UInt uiPartIdxRB;
+  deriveRightBottomIdx( eCUMode, uiPartIdx, uiPartIdxRB );  
+  UInt uiAbsPartIdxTmp = g_auiZscanToRaster[uiPartIdxRB];
+
+  if (( m_pcPic->getCU(m_uiCUAddr)->getCUPelX() + g_auiRasterToPelX[uiAbsPartIdxTmp] + m_pcPic->getMinCUWidth() )>= m_pcSlice->getSPS()->getPicWidthInLumaSamples() )
+  {
+    riLCUIdxRBNb  = -1;
+    riPartIdxRBNb = -1;
+  }
+  else if(( m_pcPic->getCU(m_uiCUAddr)->getCUPelY() + g_auiRasterToPelY[uiAbsPartIdxTmp] + m_pcPic->getMinCUHeight() )>= m_pcSlice->getSPS()->getPicHeightInLumaSamples() )
+  {
+    riLCUIdxRBNb  = -1;
+    riPartIdxRBNb = -1;
+  }
+  else
+  {
+    if ( ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 ) &&           // is not at the last column of LCU 
+      ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) ) // is not at the last row    of LCU
+    {
+      riPartIdxRBNb = g_auiRasterToZscan[ uiAbsPartIdxTmp + uiNumPartInCUWidth + 1 ];
+      riLCUIdxRBNb  = uiLCUIdx; 
+    }
+    else if ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 )           // is not at the last column of LCU But is last row of LCU
+    {
+      riPartIdxRBNb = -1;
+      riLCUIdxRBNb  = -1;
+    }
+    else if ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) // is not at the last row of LCU But is last column of LCU
+    {
+      riPartIdxRBNb = g_auiRasterToZscan[ uiAbsPartIdxTmp + 1 ];
+      riLCUIdxRBNb = uiLCUIdx + 1;
+    }
+    else //is the right bottom corner of LCU                       
+    {
+      riPartIdxRBNb = -1;
+      riLCUIdxRBNb  = -1;
+    }
+  }
+}
+
+
+Void TComDataCU::getDisMvpCandNBDV( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo , Bool bParMerge
 #if MERL_VSP_C0152
                                 , Bool bDepthRefine
@@ -5276,203 +5082,109 @@
                                 )
 {
-  PartSize eCUMode = getPartitionSize( uiPartAddr );
-  TComDataCU* pcTmpCU = NULL;
-  pDInfo->iN = 0;
-
-  RefPicList eRefPicList = REF_PIC_LIST_0 ;
-  //-- Get Spatial MV
-  UInt uiPartIdxLT, uiPartIdxRT, uiPartIdxLB;
-  UInt uiNumPartInCUWidth = m_pcPic->getNumPartInWidth();
-
-  const Int iNumofDvMCP = 7;
-#if MTK_RELEASE_DV_CONSTRAINT_C0129
-  Int   aiDvMcpDvCandX[2][iNumofDvMCP] = {{0,},    {0,}}; // dummy, 5 spatial + 1 temporal
-  Int   aiDvMcpDvCandY[2][iNumofDvMCP] = {{0,},    {0,}}; // dummy, 5 spatial + 1 temporal
-#else
-  Int   aiDvMcpDvCand[2][iNumofDvMCP] = {{0,},    {0,}}; // dummy, 5 spatial + 1 temporal
-#endif
-  Bool  abDvMcpFlag  [2][iNumofDvMCP] = {{false,},{false,}}; 
-  TComMv cTmpMvPred, cMv;
-  Bool  bTmpIsSkipped = false;
-  Bool  bDvMcpIsFound = false;
-  Int   iLCUAddrDiff = 0;
-
+  //// ******* Init variables ******* /////
+  // Init disparity struct for results
+  pDInfo->iN = 0;    
+
+  // Init struct for disparities from MCP neighboring blocks
+  McpDisInfo cMvpDvInfo;
+  cMvpDvInfo.m_bFound = false; 
+  for (UInt iCurDvMcpCand = 0; iCurDvMcpCand < MCP_DIS_CANS; iCurDvMcpCand++)
+  {
+    for (UInt iList = 0; iList < 2; iList++)
+    {
+      cMvpDvInfo.m_acMvCand[iList][iCurDvMcpCand].setZero();
+      cMvpDvInfo.m_aVIdxCan[iList][iCurDvMcpCand] = 0; 
+      cMvpDvInfo.m_bAvailab[iList][iCurDvMcpCand] = false; 
+    }
+  }
+
+  // Get Positions  
+  PartSize eCUMode    = getPartitionSize( uiPartAddr );    
+  UInt uiPartIdxLT, uiPartIdxRT, uiPartIdxLB;  
+
+  deriveLeftRightTopIdxGeneral( eCUMode, uiPartAddr, uiPartIdx, uiPartIdxLT, uiPartIdxRT );
+  deriveLeftBottomIdxGeneral  ( eCUMode, uiPartAddr, uiPartIdx, uiPartIdxLB );
+
+  // Get parameters for parallel merge
   Int xP, yP, nPSW, nPSH;
   if( bParMerge)
     this->getPartPosition(uiPartIdx, xP, yP, nPSW, nPSH);
 
-  deriveLeftRightTopIdxGeneral( eCUMode, uiPartAddr, uiPartIdx, uiPartIdxLT, uiPartIdxRT );
-  deriveLeftBottomIdxGeneral( eCUMode, uiPartAddr, uiPartIdx, uiPartIdxLB );
-
-#if MTK_SAIT_TEMPORAL_FIRST_ORDER_C0141_C0097
-  // copied from getInterMergeCand()
+  //// ******* Get disparity from temporal neighboring blocks ******* /////
   if ( getSlice()->getPPS()->getEnableTMVPFlag() )
   {
     TComMv cColMv;
     Int iTargetViewIdx = 0;
-    Int iTStartViewIdx = 0;
-    UInt uiPartIdxRB, uiBRIdx;
-#if !MTK_SIMPLIFY_DVTC_C0135
-    Int uiViewIdxCurr= getSlice()->getViewId();
-#endif
+    Int iTStartViewIdx = 0;    
+
+    ///*** Derive center position ***
     UInt uiPartIdxCenter;
+    Int  uiLCUIdx   = getAddr();
+
     xDeriveCenterIdx( eCUMode, uiPartIdx, uiPartIdxCenter );
 
-    Int uiLCUIdx = getAddr();
-    Int uiLCUnew = uiLCUIdx;
-    eCUMode = getPartitionSize( 0 );
-    deriveRightBottomIdx( eCUMode, uiPartIdx, uiPartIdxRB );  
-    uiBRIdx = uiPartIdxLT;
-    UInt uiAbsPartIdxTmp = g_auiZscanToRaster[uiPartIdxRB];
-#if MTK_SIMPLIFY_DVTC_C0135
-    if (( m_pcPic->getCU(m_uiCUAddr)->getCUPelX() + g_auiRasterToPelX[uiAbsPartIdxTmp] + m_pcPic->getMinCUWidth() )>= m_pcSlice->getSPS()->getPicWidthInLumaSamples() )
-    {
-      uiLCUnew = -1;
-    }
-    else if(( m_pcPic->getCU(m_uiCUAddr)->getCUPelY() + g_auiRasterToPelY[uiAbsPartIdxTmp] + m_pcPic->getMinCUHeight() )>= m_pcSlice->getSPS()->getPicHeightInLumaSamples() )
-    {
-      uiLCUnew = -1;
-    }
-    else
-#else
-    if ( (( m_pcPic->getCU(m_uiCUAddr)->getCUPelX() + g_auiRasterToPelX[uiAbsPartIdxTmp] + m_pcPic->getMinCUWidth() ) < m_pcSlice->getSPS()->getPicWidthInLumaSamples() ) &&(( m_pcPic->getCU(m_uiCUAddr)->getCUPelY() + g_auiRasterToPelY[uiAbsPartIdxTmp] + m_pcPic->getMinCUHeight() ) < m_pcSlice->getSPS()->getPicHeightInLumaSamples() ))  // image boundary check
-#endif
-    {
-      if ( ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 ) &&           // is not at the last column of LCU 
-      ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) ) // is not at the last row    of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ uiAbsPartIdxTmp + uiNumPartInCUWidth + 1 ];
-      }
-      else if ( uiAbsPartIdxTmp % uiNumPartInCUWidth < uiNumPartInCUWidth - 1 )           // is not at the last column of LCU But is last row of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ (uiAbsPartIdxTmp + uiNumPartInCUWidth + 1) % m_pcPic->getNumPartInCU() ];
-#if MTK_SIMPLIFY_DVTC_C0135
-        uiLCUnew = -1;
-#else
-        uiLCUnew = uiLCUIdx + m_pcPic->getFrameWidthInCU();
-#endif
-      }
-      else if ( uiAbsPartIdxTmp / uiNumPartInCUWidth < m_pcPic->getNumPartInHeight() - 1 ) // is not at the last row of LCU But is last column of LCU
-      {
-        uiBRIdx = g_auiRasterToZscan[ uiAbsPartIdxTmp + 1 ];
-        uiLCUnew = uiLCUIdx + 1;
-      }
-      else //is the right bottom corner of LCU                       
-      {
-        uiBRIdx = 0;
-#if MTK_SIMPLIFY_DVTC_C0135
-        uiLCUnew = -1;
-#else
-        uiLCUnew = uiLCUIdx + m_pcPic->getFrameWidthInCU() + 1;
-#endif
-      }
-    }
-    const Int iNumofCandPic = 2;
-    for(Int i =0; i < iNumofCandPic; i++)
-    {
-      Int lpRef=0;
-      if(i == 0)
-      {   //check the col-located picture
-        eRefPicList = RefPicList(getSlice()->isInterB() ? getSlice()->getColDir() : 0);
-#if COLLOCATED_REF_IDX
-        lpRef = getSlice()->getColRefIdx();
-#else
-        Int lpRef = 0;
-#endif
-      }
-      else
-      {
-        if(!(getPic()->getRapbCheck()))
+    ///*** Derive bottom right neighbour position ***
+    eCUMode          = getPartitionSize( 0 ); // Necessary?    
+    Int iLCUIdxRBNb  = -1;    
+    Int iPartIdxRBNb = -1;
+
+    xDeriveRightBottomNbIdx( eCUMode, uiPartIdx, iLCUIdxRBNb, iPartIdxRBNb );
+
+    ///*** Search temporal candidate pictures for disparity vector ***
+    const Int iNumCandPics = 2;
+    for(Int curCandPic = 0; curCandPic < iNumCandPics; curCandPic++)
+    {
+      // Get candidate picture
+      RefPicList eCurRefPicList   = REF_PIC_LIST_0 ;
+      Int        curCandPicRefIdx = 0;
+
+      if( curCandPic == 0 ) // check the co-located picture
+      { 
+        eCurRefPicList   = RefPicList(getSlice()->isInterB() ? getSlice()->getColDir() : 0);
+        curCandPicRefIdx = getSlice()->getColRefIdx();
+      }
+      else                  // check RAP
+      {
+        if( !(getPic()->getRapbCheck()) )
           break;
-        eRefPicList=getPic()->getRapRefList();
-        lpRef=getPic()->getRapRefIdx();
-      }
-
-      if( m_pcSlice->getViewId() == getSlice()->getRefPic( eRefPicList, lpRef)->getViewId() ) 
-      {
-#if !MTK_SIMPLIFY_DVTC_C0135
-        if (uiViewIdxCurr > 1)  
+
+        eCurRefPicList   = getPic()->getRapRefList();
+        curCandPicRefIdx = getPic()->getRapRefIdx();
+      }
+
+      // Check BR and Center       
+      if( m_pcSlice->getViewId() == getSlice()->getRefPic( eCurRefPicList, curCandPicRefIdx)->getViewId() ) 
+      {
+        for(Int curPosition = 0; curPosition < 2; curPosition++) 
         {
-#endif
-          if( (uiLCUnew >= 0 && xGetColDisMV( eRefPicList, lpRef, uiLCUnew, uiBRIdx, cColMv, iTargetViewIdx, iTStartViewIdx)) )
+          Bool bCheck = false; 
+          if ( curPosition == 0 && iLCUIdxRBNb >= 0 )
+            bCheck = xGetColDisMV( eCurRefPicList, curCandPicRefIdx, iLCUIdxRBNb, iPartIdxRBNb,  cColMv, iTargetViewIdx, iTStartViewIdx);
+
+          if (curPosition == 1 )
+            bCheck = xGetColDisMV( eCurRefPicList, curCandPicRefIdx, uiLCUIdx,   uiPartIdxCenter,  cColMv, iTargetViewIdx, iTStartViewIdx );
+
+          if( bCheck )
           {
             clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
+            TComPic* picDepth = getSlice()->getRefPicBaseDepth();
+            if (picDepth && bDepthRefine)
+              estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
+
             pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
             pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
             return ;
           }
-#if !MTK_SIMPLIFY_DVTC_C0135
-        }
-#endif
-        if(xGetColDisMV( eRefPicList, lpRef, uiLCUIdx, uiPartIdxCenter,  cColMv, iTargetViewIdx, iTStartViewIdx ))
-        {
-          clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
-          return ;
-        }
-#if !MTK_SIMPLIFY_DVTC_C0135
-        if(uiViewIdxCurr == 1)  
-        {
-          if( (uiLCUnew >= 0 && xGetColDisMV( eRefPicList, lpRef, uiLCUnew, uiBRIdx, cColMv, iTargetViewIdx, iTStartViewIdx)) ) 
-          {
-            clipMv(cColMv);
-#if !MERL_MTK_VSP_DVP_REFINE_C0152_C0131
-            pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-            pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-#else
-            {
-              TComPic* picDepth = NULL;
-              picDepth = getSlice()->getRefPicBaseDepth();
-              if (picDepth && bDepthRefine)
-#if LGE_SIMP_DVP_REFINE_C0112
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv, true);
-#else
-                estimateDVFromDM(uiPartIdx, picDepth, uiPartAddr, &cColMv);
-#endif
-              pDInfo->m_acMvCand[ pDInfo->iN] = cColMv;
-              pDInfo->m_aVIdxCan[ pDInfo->iN++] = iTargetViewIdx;
-            }
-#endif
-            return ;
-          }
-        }
-#endif
-      }
-    }
+        } // Loop positions
+      }
+    } // Loop candidate views
   } // if TMVP Flag
-#endif
+
   UInt uiIdx = 0;
+  Bool        bCheckMcpDv = false;   
+  TComDataCU* pcTmpCU     = NULL;
+
+
+  //// ******* Get disparity from left block ******* /////
   pcTmpCU = getPULeft(uiIdx, uiPartIdxLB, true, false);
   if ( uiPartIdx == 1 && (eCUMode == SIZE_Nx2N || eCUMode == SIZE_nLx2N || eCUMode == SIZE_nRx2N) )
